=== debian/changelog ===
libzstd (1.4.4+dfsg-3) unstable; urgency=medium

  * Team upload.
  * Source only upload.

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Thu, 13 Feb 2020 10:40:13 +0100

libzstd (1.4.4+dfsg-2) unstable; urgency=medium

  * Team upload.
  * Install all the man pages.
  * Standards-Version: 4.5.0 (routine-update)
  * debhelper-compat 12 (routine-update)

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Thu, 13 Feb 2020 09:10:22 +0100

libzstd (1.4.4+dfsg-1) unstable; urgency=medium

  [ Justin Aplin ]
  * New upstream version 1.4.4+dfsg
  * Refresh patches
  * Call Salsa CI with variable DB_BUILD_PARAM: '-v1.1.2-1', since this is the
    oldest version in active repositories
  * Add Rules-Requires-Root: binary-targets to debian/control to comply with
    current DPM
  * Bump Standards-Version to 4.4.1, changes noted above
  * Update symbols file for libzstd1
  * Call dh_makeshlibs with -V 'libzstd1 (>= 1.4.4)', since this version
    introduced new public symbols
  * Add an entry in debian/source/lintian-overrides to prevent libzstd1's
    Section entry from triggering binary-control-field-duplicates-source,
    since this field is necessary for the build

 -- Alexandre Mestiashvili <mestia@debian.org>  Fri, 15 Nov 2019 17:15:40 +0100
