=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
 Section: libs
 Priority: optional
 Build-Depends: d-shlibs,
-               debhelper-compat (= 12),
+               debhelper-compat (= 13),
                help2man,
                liblz4-dev,
                liblzma-dev,
