=== debian/rules ===
--- 
+++ 
@@ -5,6 +5,10 @@
 DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
 export DEB_BUILD_MAINT_OPTIONS=hardening=+all
+# FIXME: see https://lists.debian.org/debian-mentors/2020/08/msg00032.html
+#        this line shoud go once upstream has fixed
+#        https://github.com/facebook/zstd/issues/2204
+export DEB_CFLAGS_MAINT_APPEND = -fno-strict-aliasing
 
 # Upstream's makefiles will respect PREFIX, and this means we avoid a patch
 export PREFIX=/usr
@@ -25,7 +29,8 @@
 	dh_auto_clean --sourcedirectory=contrib/pzstd
 
 override_dh_auto_build:
-	dh_auto_build -- ZSTD_LEGACY_MULTITHREADED_API=1
+	dh_auto_build
+	dh_auto_build --sourcedirectory=lib -- all libzstd.pc libzstd
 	dh_auto_build --sourcedirectory=contrib/pzstd/ -- pzstd
 
 override_dh_install:
@@ -41,7 +46,7 @@
 	dh_install
 
 override_dh_makeshlibs:
-	dh_makeshlibs -plibzstd1 -V'libzstd1 (>= 1.4.4)' --add-udeb=libzstd1-udeb
+	dh_makeshlibs -plibzstd1 -V'libzstd1 (>= 1.4.5)' --add-udeb=libzstd1-udeb
 
 override_dh_installman:
 	dh_installman
